

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>TimeAxis &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script src="../../../_static/js/bootstrap.min.js"></script>
        <script src="../../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
    <link rel="next" title="TimeSeries" href="time_series.html" />
    <link rel="prev" title="Calendar" href="calendar.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../getting_started.html">Getting started</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="time.html">Time</a></li>
<li class="toctree-l2"><a class="reference internal" href="calendar.html">Calendar</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">TimeAxis</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#create-a-timeaxis-object">Create a TimeAxis object</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#fixed-interval-time-axis">Fixed interval time axis</a></li>
<li class="toctree-l4"><a class="reference internal" href="#ireggular-interval-time-axis">Ireggular interval time axis</a></li>
<li class="toctree-l4"><a class="reference internal" href="#calendar-time-axis">Calendar time axis</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#a-few-helpful-functions">A few helpful functions</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="time_series.html">TimeSeries</a></li>
<li class="toctree-l2"><a class="reference internal" href="dts.html">Distributed Time Series (DTS)</a></li>
<li class="toctree-l2"><a class="reference internal" href="notebooks.html">Examples</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../getting_started.html">Getting started</a> &raquo;</li>
        
      <li>TimeAxis</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../../_sources/content/time_series/getting_started/time_axis.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="timeaxis">
<span id="usagetimeaxis"></span><h1>TimeAxis<a class="headerlink" href="#timeaxis" title="Permalink to this headline">¶</a></h1>
<p>The chapter <a class="reference internal" href="../concepts/time_series.html#concepttimeseries"><span class="std std-ref">What is a time series?</span></a> outlined that a sequence of time points can be interpreted as
a list of non-overlapping time periods. This is represented by a <code class="docutils literal notranslate"><span class="pre">TimeAxis</span></code> object which is able
to deal with fixed period time series as well as irregularly spaced time periods.</p>
<p>As the <code class="docutils literal notranslate"><span class="pre">TimeAxis</span></code> object is fundamental to a <a class="reference internal" href="time_series.html#usagetimeseries"><span class="std std-ref">TimeSeries</span></a> object, it needs to be
created before the actual TimeSeries can be created. Its usage requires understanding
<a class="reference internal" href="calendar.html#usagecalendartime"><span class="std std-ref">Calendar and time</span></a>.</p>
<p>There are several ways to create a <code class="docutils literal notranslate"><span class="pre">TimeAxis</span></code> and the right approach depends on the faced problem
and available data.</p>
<div class="section" id="create-a-timeaxis-object">
<h2>Create a TimeAxis object<a class="headerlink" href="#create-a-timeaxis-object" title="Permalink to this headline">¶</a></h2>
<div class="section" id="fixed-interval-time-axis">
<h3>Fixed interval time axis<a class="headerlink" href="#fixed-interval-time-axis" title="Permalink to this headline">¶</a></h3>
<p>The simplest time axis is defined by a start time, a delta time value and the number of periods.
This is also the most efficient one.
To create the time axis we need a starting point <code class="docutils literal notranslate"><span class="pre">t0</span></code>, length of periods <code class="docutils literal notranslate"><span class="pre">dt</span></code> and how
many periods <code class="docutils literal notranslate"><span class="pre">n</span></code>.
The code below will create a time axis from the 01.01.2020 UTC until 08.01.2020 UTC with 24 hour
periods.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">shyft.time_series</span> <span class="kn">import</span> <span class="n">Calendar</span><span class="p">,</span> <span class="n">TimeAxis</span><span class="p">,</span> <span class="n">deltahours</span>

<span class="c1"># Create a utc-based calendar.</span>
<span class="n">utc</span> <span class="o">=</span> <span class="n">Calendar</span><span class="p">()</span>

<span class="n">t0</span> <span class="o">=</span> <span class="n">utc</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2020</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
<span class="n">dt</span> <span class="o">=</span> <span class="n">deltahours</span><span class="p">(</span><span class="mi">24</span><span class="p">)</span> <span class="c1"># alternatively: dt = Calendar.DAY</span>
<span class="n">n</span> <span class="o">=</span> <span class="mi">7</span>

<span class="n">ta</span> <span class="o">=</span> <span class="n">TimeAxis</span><span class="p">(</span><span class="n">start</span><span class="o">=</span><span class="n">t0</span><span class="p">,</span> <span class="n">delta_t</span><span class="o">=</span><span class="n">dt</span><span class="p">,</span> <span class="n">n</span><span class="o">=</span><span class="n">n</span><span class="p">)</span>
<span class="c1"># TimeAxis(&#39;2020-01-01T00:00:00Z&#39;, 86400s, 7)</span>
</pre></div>
</div>
</div>
<div class="section" id="ireggular-interval-time-axis">
<h3>Ireggular interval time axis<a class="headerlink" href="#ireggular-interval-time-axis" title="Permalink to this headline">¶</a></h3>
<p>A time axis with irregularly spaced time periods can be created with the list of defined time
points. The input time points are the starting point of each period, and we must add a last
argument <code class="docutils literal notranslate"><span class="pre">t_end</span></code> to declare the end of the last period.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">osl</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="p">(</span><span class="s1">&#39;Europe/Oslo&#39;</span><span class="p">)</span>

<span class="n">t0</span> <span class="o">=</span> <span class="n">osl</span><span class="o">.</span><span class="n">time</span><span class="p">(</span><span class="mi">2021</span><span class="p">,</span> <span class="mi">3</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
<span class="n">dt</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">Calendar</span><span class="o">.</span><span class="n">MONTH</span>
<span class="n">n</span> <span class="o">=</span> <span class="mi">5</span>
<span class="n">ta_osl</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">TimeAxis</span><span class="p">(</span><span class="n">calendar</span><span class="o">=</span><span class="n">osl</span><span class="p">,</span> <span class="n">start</span><span class="o">=</span><span class="n">t0</span><span class="p">,</span> <span class="n">delta_t</span><span class="o">=</span><span class="n">dt</span><span class="p">,</span> <span class="n">n</span><span class="o">=</span><span class="n">n</span><span class="p">)</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If the <code class="docutils literal notranslate"><span class="pre">t_end</span></code> is not supplied the time axis will assume that the last point in the list
is the end of the last period.</p>
</div>
</div>
<div class="section" id="calendar-time-axis">
<h3>Calendar time axis<a class="headerlink" href="#calendar-time-axis" title="Permalink to this headline">¶</a></h3>
<p>The third option when creating a time axis is a calendar time axis, this will make the time axis
aware of what a month is in a calendar setting, as well as daylight savings time.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">ta_fixed</span> <span class="o">=</span> <span class="n">sts</span><span class="o">.</span><span class="n">TimeAxis</span><span class="p">(</span><span class="n">t0</span><span class="p">,</span> <span class="n">dt</span><span class="p">,</span> <span class="n">n</span><span class="p">)</span>
<span class="c1"># TimeAxis(&#39;2021-03-28T20:00:00Z&#39;, 3600s, 5)</span>

<span class="k">for</span> <span class="n">t_osl</span><span class="p">,</span> <span class="n">t_fix</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">ta_osl</span><span class="o">.</span><span class="n">time_points</span><span class="p">,</span> <span class="n">ta_fixed</span><span class="o">.</span><span class="n">time_points</span><span class="p">):</span>
    <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s1">&#39;</span><span class="si">{</span><span class="n">osl</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">t_osl</span><span class="p">))</span><span class="si">}</span><span class="s1">  |  </span><span class="si">{</span><span class="n">osl</span><span class="o">.</span><span class="n">to_string</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">t_fix</span><span class="p">))</span><span class="si">}</span><span class="s1">&#39;</span><span class="p">)</span>

</pre></div>
</div>
<p>And we can compare this with a fixed time axis</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="c1"># 2021-05-01T00:00:00+02  |  2021-04-30T01:00:00+02</span>
<span class="c1"># 2021-06-01T00:00:00+02  |  2021-05-30T01:00:00+02</span>
<span class="c1"># 2021-07-01T00:00:00+02  |  2021-06-29T01:00:00+02</span>
<span class="c1"># 2021-08-01T00:00:00+02  |  2021-07-29T01:00:00+02</span>


<span class="n">total_period</span> <span class="o">=</span> <span class="n">osl_ta</span><span class="o">.</span><span class="n">total_period</span><span class="p">()</span>
<span class="c1"># [2021-02-28T23:00:00Z,2021-07-31T22:00:00Z&gt;</span>

<span class="n">time_points</span> <span class="o">=</span> <span class="n">osl_ta</span><span class="o">.</span><span class="n">time_points</span>
<span class="c1"># array([1614553200, 1617228000, 1619820000, 1622498400, 1625090400,</span>
<span class="c1">#        1627768800])</span>
</pre></div>
</div>
<p>Here we see that the calendar time axis (first column) always start the first of every calendar
month at the start of the day, while in the fixed time axis it naively goes 2592000 seconds
(<code class="docutils literal notranslate"><span class="pre">Calendar.MONTH</span></code>) forward.</p>
</div>
</div>
<div class="section" id="a-few-helpful-functions">
<h2>A few helpful functions<a class="headerlink" href="#a-few-helpful-functions" title="Permalink to this headline">¶</a></h2>
<p>A few helpful functions that helps us explore a given time axis.</p>
<p><code class="docutils literal notranslate"><span class="pre">total_period()</span></code> returns a <code class="docutils literal notranslate"><span class="pre">UtcPeriod</span></code> that spans the total period of the time axis.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">total_period</span> <span class="o">=</span> <span class="n">osl_ta</span><span class="o">.</span><span class="n">total_period</span><span class="p">()</span>
<span class="c1"># [2021-02-28T23:00:00Z,2021-07-31T22:00:00Z&gt;</span>
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">time_points</span></code> returns an <code class="docutils literal notranslate"><span class="pre">numpy.array</span></code> with each starting point per period
as well as the end of the last period.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">time_points</span> <span class="o">=</span> <span class="n">osl_ta</span><span class="o">.</span><span class="n">time_points</span>
<span class="c1"># array([1614553200, 1617228000, 1619820000, 1622498400, 1625090400,</span>
<span class="c1">#        1627768800])</span>
</pre></div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p><code class="docutils literal notranslate"><span class="pre">time_points</span></code> returns time points in second resolution, as of now we need to use
<code class="docutils literal notranslate"><span class="pre">time_points_double</span></code> to get sub-second resolution</p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">size()</span></code> returns the number of periods in the time axis.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">size_ta</span> <span class="o">=</span> <span class="n">osl_ta</span><span class="o">.</span><span class="n">size</span><span class="p">()</span>
<span class="c1"># 5</span>
</pre></div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="time_series.html" class="btn btn-neutral float-right" title="TimeSeries" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="calendar.html" class="btn btn-neutral float-left" title="Calendar" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>